#!/bin/bash

# uninstall logic for UKCloudBackupPro 7.15.6.55
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/UKCloudBackupPro.app/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for UKCloudBackupPro"
    touch "/Applications/UKCloudBackupPro.app/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
#if [ -e "/Applications/UKCloudBackupPro/aua/bin" ]; then
#    echo "Shutdown AutoUpdateAgent for UKCloudBackupPro"
#    sh "/Applications/UKCloudBackupPro/aua/bin/shutdown.sh"
#    echo "Wait 5 seconds before AutoUpdateAgent exits"
#    sleep 5
#fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/UKCloudBackupPro.app/bin/taskkill" "/Applications/UKCloudBackupPro.app/jvm/bin/bJW"
sh "/Applications/UKCloudBackupPro.app/bin/taskkill" "/Applications/UKCloudBackupPro.app/jvm/bin/bschJW"
sh "/Applications/UKCloudBackupPro.app/bin/taskkill" "/Applications/UKCloudBackupPro.app/jvm/bin/java"


###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/UKCloudBackupPro" ]; then
    echo "Remove Scheduler for UKCloudBackupPro from service"
    rm -rf "/Library/StartupItems/UKCloudBackupPro"
fi

# Remove Launch Daemons
if [ -e "/Library/LaunchDaemons/com.UKCloudBackupPro.scheduler.plist" ]; then
    echo "Remove LaunchDaemons for com.UKCloudBackupPro.scheduler from service"
    launchctl unload "/Library/LaunchDaemons/com.UKCloudBackupPro.scheduler.plist"
    rm -f "/Library/LaunchDaemons/com.UKCloudBackupPro.scheduler.plist"
fi
# Remove AutoUpdateAgent
#if [ -e "/Library/StartupItems/UKCloudBackupPro-AutoUpdate" ]; then
#    echo "Remove AutoUpdateAgent for UKCloudBackupPro from service"
#    rm -rf "/Library/StartupItems/UKCloudBackupPro-AutoUpdate"
#fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/UKCloudBackupPro" ]; then
        echo "Remove Desktop Link UKCloudBackupPro from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/UKCloudBackupPro"
        echo "Removed UKCloudBackupPro Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/UKCloudBackupPro" ]; then
        echo "Remove Desktop Link UKCloudBackupPro from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/UKCloudBackupPro"
        echo "Removed UKCloudBackupPro Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/UKCloudBackupPro" ]; then
        echo "Remove Desktop Link UKCloudBackupPro from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/UKCloudBackupPro"
        echo "Removed UKCloudBackupPro Desktop Link"
    fi

done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove UKCloudBackupPro
cd /
if [ -e "/Applications/UKCloudBackupPro.app" ]; then
    echo "Remove UKCloudBackupPro from Your Mac OS X"
    rm -rf "/Applications/UKCloudBackupPro.app"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/obm-mac.pkg" ]; then
    echo "Remove Mac OS X Receipt for obm-mac.pkg (Path: /Library/Receipts/obm-mac.pkg)"
    rm -rf "/Library/Receipts/obm-mac.pkg"
fi
